function [fls] = get_spectral_images(fls)

for line_nr = 1:length(fls.fluolines)
    spectrum_range = find_spectral_range(fls, fls.fluolines(line_nr));
    fls.fluolines(line_nr).image = squeeze(sum(fls.exp.data(spectrum_range,:,:),1));
end

function range = find_spectral_range(fls, energy)
    index_center = find(abs(fls.calib.energies - energy.energy) == ...
                        min(abs(fls.calib.energies - energy.energy)), 1) - 1;
    index_start  = find(abs(fls.calib.energies - energy.energy + energy.bandwidth/2) == ...
                        min(abs(fls.calib.energies - energy.energy + energy.bandwidth/2)),1) - 1;
    index_end    = find(abs(fls.calib.energies - energy.energy - energy.bandwidth/2) == ...
                        min(abs(fls.calib.energies - energy.energy - energy.bandwidth/2)),1) - 1;
    range  = [index_start:index_end];
end

end