function [fls] = get_spectral_range(fls)
    fls.exp.spectrum = sum(sum(fls.exp.data, 2), 3);

    fsp = figure(4001);
    clf
    
    if ~isempty(fls.calib.energies)
        semilogy(fls.calib.energies, fls.exp.spectrum)
        xlabel('Energy, [keV]')
    end
    
    title({'Please mark peaks of interest with two points on left and right of each peak.',...
           'Pressing Backspace or Delete removes the previously selected point.',...
           'Pressing Return or Enter ends the selection.'})
    [spectral_range.x, spectral_range.y] = getpts(fsp);
    
    while mod(length(spectral_range.x),2)
        warndlg('Number of markers needs to be even. Please try again.', 'Error')
        pause(0.5);
        [spectral_range.x, spectral_range.y] = getpts(fsp);
    end
    
    fls.fluolines = [];
    for energy_nr = 1:length(spectral_range.x)/2
        energy_1 = spectral_range.x((energy_nr - 1)*2 + 1);
        energy_2 = spectral_range.x((energy_nr - 1)*2 + 2);
        bandwidth = max([energy_1 energy_2]) - min([energy_1 energy_2]);
        central_energy = min([energy_1 energy_2]) + bandwidth / 2;
        fls.fluolines(energy_nr).energy = central_energy;
        fls.fluolines(energy_nr).bandwidth = bandwidth;
    end
    close(fsp)
end