function [fls] = manual_line_id(fls)

for energy_nr = 1:length(fls.fluolines)
    fls.fluolines(energy_nr).id = request_line_id(fls, energy_nr);
    close(fsp);
end
export_line_ids(fls);

    function [line_id] = request_line_id(fls, energy_nr)
        fsp = figure(4001);
        clf
        
        fls.exp.spectrum = sum(sum(fls.exp.data, 2), 3);
        
        if ~isempty(fls.calib.energies)
            semilogy(fls.calib.energies, fls.exp.spectrum)
            xlabel('Energy, [keV]')
        end
        
        title(['Manual peak indentification.'])
        hold on
        energy_1 = fls.fluolines(energy_nr).energy - fls.fluolines(energy_nr).bandwidth / 2;
        energy_2 = fls.fluolines(energy_nr).energy + fls.fluolines(energy_nr).bandwidth / 2;
        index_start = find_energy_index(fls.calib.energies, min([energy_1 energy_2]));
        index_stop = find_energy_index(fls.calib.energies, max([energy_1 energy_2]));
        H=area(fls.calib.energies(index_start:index_stop), fls.exp.spectrum(index_start:index_stop));
        set(H(1),'FaceColor','r');
        alpha(.3);
        max_index = index_start + find(fls.exp.spectrum(index_start:index_stop) ==...
                                       max(fls.exp.spectrum(index_start:index_stop)), 1) - 1;
        value_string = sprintf('%2.3f keV', round(fls.calib.energies(max_index), 2));
        text(fls.calib.energies(max_index), fls.exp.spectrum(max_index)+1e6, value_string);
        hold off
        line_id=input('help to identify the peak\n','s');
    end
        
    function index = find_energy_index(spectrum_points, energy)
        index = find(abs(spectrum_points - energy) == ...
            min(abs(spectrum_points - energy)), 1) - 1;
    end
        
    end