function [] = plot_power_spectrum_res(fls)

[clr, fields] = load_color_scheme('cblind');

figure(4003)
for i = 1:length(fls.fluolines)
    y_values = fls.fluolines(i).ps_resolution(2, :);
    x_values = fls.fluolines(i).ps_resolution(1, :); % assuming um^-1
    loglog(x_values, y_values, 'color', clr.(fields{i}), 'LineWidth',2.5)
    hold on
end

x_axis_min = round(min(x_values), 2);
x_axis_max = round(max(x_values), 2);
x_axis_half = (x_axis_max-x_axis_min)/2;
x_axis_quarter = (x_axis_max-x_axis_min)/4;
x_axis_sixth = (x_axis_max-x_axis_min)/6;
xticks([x_axis_min ...
        round((x_axis_half - x_axis_quarter), 2) ...
        round((x_axis_half + x_axis_sixth), 2) ...
        x_axis_max]);

set(gcf,'color','white')
set(gca,'FontSize', 14,'FontWeight','bold','YMinorTick','off','XGrid','on', 'YGrid','on');
title('Power spectrum of fluorescence signal','FontSize', 14,'FontWeight','Bold')
xlabel('Spatial frequency [\mum^{-1}]','interpreter','Tex', 'FontSize', 14,'FontWeight','Bold')
ylabel('Intensity (a.u.)','FontSize', 14,'FontWeight','Bold');
legend(fls.fluolines.id)