function [fls] = prepare_template()
%% paths substructure
fls.    paths.matlab_folder = '/das/work/p16/p16588/matlab_dima/';
fls.    paths.data = '/das/work/p16/p16588/x123/gccDppConsoleLinux/data/x123_%05d.dat';
fls.    paths.output = '/das/work/p16/p16588/analysis_dima/';
fls.    paths.positions = '/das/work/p16/p16588/specES1/scan_positions/scan_%05d.dat';
fls.    paths.xraydb = '/das/work/p16/p16588/matlab_dima/+fluo/development/xraydb.mat';
fls.    paths.probe = '';
fls.    paths.fluolines = '';

addpath(fls.paths.matlab_folder);

%% experiment substructure
fls.    exp.scan_num = [463:524];

%% processing substructure
fls.    process.online = 0;

%% spectrum calibration substracture
fls.    calib.chan_num = 1024;
fls.    calib.step = 8.905*(8192/fls.calib.chan_num)/5656;
fls.    calib.resolution = 0.005;
fls.    calib.energies = ( 0 : ...
                           fls.calib.step : ...
                           ( fls.calib.chan_num - 1 ) * fls.calib.step );

%% fluorescence lines substructure
if isempty(fls.paths.fluolines)
    fls.    fluolines(1).energy = 6.49;    fls.    fluolines(2).energy = 6.915;
    fls.    fluolines(3).energy = 8.26;    fls.    fluolines(4).energy = 8.7;

    fls.    fluolines(1).id = 'Mn Kb1';    fls.    fluolines(2).id = 'Co Ka2';
    fls.    fluolines(3).id = 'Ni Kb1';    fls.    fluolines(4).id = 'elastic';

    bandwidth = 0.5;
    bandwidth_array = ones(1, length(fls.fluolines));
    bandwidth_array = bandwidth_array .* bandwidth;
    bandwidth_array = num2cell(bandwidth_array);
    [fls.fluolines.bandwidth] = bandwidth_array{:};
else
    fls = load_line_ids(fls);
end