function show_individual_fluo_maps(fls)
fls = get_spectral_images(fls);

% prepare the figure's axes
m = floor(sqrt(length(fls.fluolines)));
n = ceil(length(fls.fluolines)/m);

% prepare the color-blind friendly color scheme
[clr, fields] = load_color_scheme('cblind');

figure(4002)
for ii = 1:length(fls.fluolines)
    subplot(m, n, ii)
    img_color = [];
    img_color(:,:,1) = fls.fluolines(ii).image * clr.(fields{ii})(1);
    img_color(:,:,2) = fls.fluolines(ii).image * clr.(fields{ii})(2);
    img_color(:,:,3) = fls.fluolines(ii).image * clr.(fields{ii})(3);
    img_color = img_color/max(img_color(:));
    imshow(img_color);
    title(fls.fluolines(ii).id, 'FontSize', 16);
end

a = axes;
main_title = title('Fluorescent maps', 'FontSize', 20,'FontWeight','Bold');
a.Visible = 'off';
main_title.Visible = 'on';

end