Setup
=====
#tested with libDetXR 0.0.3-61 on PC9477
export MKL_LIBRARY_PATH=/afs/psi.ch/sys/linux/opt/intel/intel-14.0.2.x86_64/composer_xe_2013_sp1.2.144/mkl/lib/intel64
export HDF5_LIBRARY_PATH=/home/zamofing_t/Documents/prj/WorkBench/hdf5/lib

alias ptychoRun="LD_LIBRARY_PATH=$MKL_LIBRARY_PATH:$HDF5_LIBRARY_PATH OMP_NUM_THREADS=10 /home/zamofing_t/Documents/prj/ptycho_c_code/src/ptycho --feedback_interval=5 --verbose=1 --diffmap_iterations 20 --max_mlh_iterations=20"
alias ptychoPrep=/home/zamofing_t/Documents/prj/libDetXR/python/libDetXR/procPtycho.py
alias ptychoShow=/home/zamofing_t/Documents/prj/libDetXR/python/libDetXR/ptycho/showPtycho.py


#for CSAXS:
ssh x12sa-cn-1
export PATH=/opt/gfa/python-2.7/2.3.0/bin:$PATH
source activate xblpython
alias ptychoRun="echo 'execute the ptychography...'"
alias ptychoPrep=/opt/gfa/python-2.7/2.3.0/pkgs/libdetxr-0.0.3.64-py27_0/lib/python2.7/site-packages/libDetXR/procPtycho.py
alias ptychoShow=/opt/gfa/python-2.7/2.3.0/pkgs/libdetxr-0.0.3.64-py27_0/lib/python2.7/site-packages/libDetXR/ptycho/showPtycho.py


h5pyViewer
ptychoPrep
ptychoPrep -h
ptychoRun
ptychoShow

OUTDIR=/tmp
INDIR=/afs/psi.ch/project/cxs/CDI/cSAXS_sxdm_2014_07_omny_commissioning
SOURCE="[\"hdf\", \"$INDIR/eiger/S00000-00999/S00033/e15285_1_00033_00000_00000.h5\", \"eh5/images\"]"
PROBE="[\"mat\",\"$INDIR/matlab/ptycho/probe_eiger_S00033_400x400_test_1_c.mat\",\"probe\"]"
OMNI=\"$INDIR/specES1/omni/omniscan_scan_00033.dat\"

OUTDIR=/tmp
INDIR=/afs/psi.ch/project/cxs/CDI/cSAXS_sxdm_2014_07_omny_commissioning
SOURCE="[\"hdf\", \"$INDIR/eiger/S00000-00999/S00034/e15285_1_00034_00000_00000.h5\", \"eh5/images\"]"
PROBE="[\"mat\",\"$INDIR/matlab/ptycho/probe_eiger_S00033_400x400_test_1_c.mat\",\"probe\"]"
OMNI=\"$INDIR/specES1/omni/omniscan_scan_00034.dat\"


cat << EOF > /tmp/ptycho.json
{
  "glob":
  {
    "dst":["hdf", "$OUTDIR/ptycho_data.hdf5"],
    "energy": 7.2525,
    "z": 7.3886,
    "ds": 75e-6
  },
  "detector":
  {
    "0":
    {
      "validMsk":"$INDIR/matlab/ptycho/eiger_valid_mask.mat",
      "trfMsk":[-1,0]
    }
  },
  "measurement":
  {
    "0":
    {
      "detector": 0,
      "probe": 0,
      "object": 0,
      "src":$SOURCE,
      "roi":[343, 255, 400, 400],
      "posParam":
      {
        "mode": "omni_opos",
        "trfPos": [[-1, 0],[0, 1]],
        "file": $OMNI
      }
    }
  },
  "initialCondition":
  {
    "dst":["hdf", "$OUTDIR/ptycho_init.hdf5"],
    "param":
    {
      "pfft_relaxation":0.05,
      "probe_regularization":0.1,
      "probe_radius":0.8,
      "diffmap_iterations":5,
      "averaging_iterations":0,
      "max_mlh_iterations":5
    },
    "probe":
    {
      "0": $PROBE
    },
    "object":
    {
      "0": ["random"]
    }
  }
}
EOF


ptychoPrep --meta $OUTDIR/ptycho.json --cmpr s-zlib4 --multiproc
#legacy should also work: ptychoPrep --meta $OUTDIR/ptycho.json --cmpr s-zlib4 --multiproc --oldHdfStruct
ptychoRun $OUTDIR/ptycho_data.hdf5 $OUTDIR/ptycho_init.hdf5 $OUTDIR/ptycho_out.hdf5
ptychoShow $OUTDIR/ptycho_out.hdf5

#Next iteration
ptycho $OUTDIR/ptycho_data.hdf5 $OUTDIR/ptycho_out.hdf5 $OUTDIR/ptycho_out2.hdf5
ptychoShow $OUTDIR/procPtychoOut2.hdf5


zamofing_t@pc9477:/afs/psi.ch/project/cxs/CDI/cSAXS_sxdm_2014_07_omny_commissioning$ find . -name '*data* .h5'
zamofing_t@pc9477:/afs/psi.ch/project/cxs/CDI/cSAXS_sxdm_2014_07_omny_commissioning$ find . -name '*probe*.h5'



ptycho_cSAXS_donnelly_omni_2015_09_S03818.json
==============================================


OUTDIR=/tmp
INDIR=/scratch/detectorData/cSAXS_donnelly_omni_2015_09
JSONDIR=/home/zamofing_t/Documents/prj/libDetXR/python/libDetXR/ptycho
#forward
#sed -e s"|\$OUTDIR|$OUTDIR|" -e s"|\$INDIR|$INDIR|" -i $JSONDIR/cSAXS_donnelly_omni_2015_09_3818_*.json
#reverse
#sed -e s"|$OUTDIR|\$OUTDIR|" -e s"|$INDIR|\$INDIR|" -i $JSONDIR/cSAXS_donnelly_omni_2015_09_3818_*.json

files:
SRC=/afs/psi.ch/project/cxs/CDI/cSAXS_donnelly_omni_2015_09
mkdir -p /scratch/detectorData/cSAXS_donnelly_omni_2015_09/
cd /scratch/detectorData/cSAXS_donnelly_omni_2015_09/
mkdir -p analysis/ specES1/omni/ matlab/
cp -r $SRC/analysis/S03818/ analysis/
cp -r $SRC/matlab/ptycho/ matlab/
cp    $SRC/specES1/omni/omniscan_scan_038*.dat specES1/omni
cp    $SRC/tar_files/pilatus_S03810-03819.tar.gz .
tar -tf pilatus_S03810-03819.tar.gz
tar -xvf pilatus_S03810-03819.tar.gz --wildcards 'pilatus_1/S03000-03999/S03818/*'
tar -xvf pilatus_S03810-03819.tar.gz --wildcards 'pilatus_1/S03000-03999/S03819/*'

ptychoShow $INDIR/analysis/S03818/S03818_S03819_initial_conditions_400x400.h5
ptychoRun $INDIR/analysis/S03818/S03818_S03819_data_400x400.h5 $INDIR/analysis/S03818/S03818_S03819_initial_conditions_400x400.h5 /tmp/ptycho_out1.hdf5
ptychoShow $OUTDIR/ptycho_out1.hdf5

#extract positions modules etc:
#python /home/zamofing_t/Documents/prj/libDetXR/python/libDetXR/ptycho/extract_cSAXS_donnelly_omni_2015_09_3818.py
#to build cSAXS_donnelly_omni_2015_09_3818_mod_badpix_pos.json
ptychoPrep --meta $JSONDIR/cSAXS_donnelly_omni_2015_09_3818_mod_badpix_pos.json --cmpr s-zlib4 --oldHdfStruct --maxPower=10262969
#h5pyViewer $INDIR/analysis/S03818/S03818_S03819_data_400x400.h5&
#h5pyViewer /tmp/ptycho_data.hdf5&
ptychoRun /tmp/ptycho_data.hdf5 $INDIR/analysis/S03818/S03818_S03819_initial_conditions_400x400.h5 /tmp/ptycho_out2.hdf5
ptychoShow $OUTDIR/ptycho_out2.hdf5
-> 'nearly same' input data but different output data!
-> the problem seems the normalization or bad_pix only once for module!!!

ptychoRun /tmp/ptycho_data.hdf5 /tmp/ptycho_init.hdf5 /tmp/ptycho_out3.hdf5
ptychoShow $OUTDIR/ptycho_out3.hdf5

/afs/psi.ch/project/cxs/CDI/cSAXS_donnelly_omni_2015_09/matlab/ptycho/ptycho_offilne_MGS_TEST_modes_S03380.m
->affine_matrix = [1 0; tan(0.55*pi/180) 1] [[1, 0],[np.tan(0.55*np.pi/180), 1]]=[[1, 0], [0.0095996057453327632, 1]]
ptychoPrep --meta $JSONDIR/cSAXS_donnelly_omni_2015_09_3818_auto.json --cmpr s-zlib4 --oldHdfStruct --maxPower=10262969
#or ptychoPrep --meta $JSONDIR/cSAXS_donnelly_omni_2015_09_3818_auto.json --cmpr s-zlib4 --multiproc
ptychoRun /tmp/ptycho_data.hdf5 $INDIR/analysis/S03818/S03818_S03819_initial_conditions_400x400.h5 /tmp/ptycho_out4.hdf5
->fails because illegal range

ptychoRun /tmp/ptycho_data.hdf5 /tmp/ptycho_init.hdf5 /tmp/ptycho_out5.hdf5
ptychoShow $OUTDIR/ptycho_out5.hdf5
-> runs !!!
-> BUT:
-> positions slightly different
-> bad pixels different

Hepler Tools: /home/zamofing_t/Documents/prj/libDetXR/python/libDetXR/ptycho/conv_mat2hdf5.py

SCRATCH
=======

ptychoPrep --meta /tmp/ptycho.json --cmpr s-zlib4 --multiproc
ptychoRun /tmp/ptycho_data.hdf5 $OUTDIR/ptycho_init.hdf5 $OUTDIR/ptycho_out3.hdf5
ptychoShow $OUTDIR/ptycho_out3.hdf5

Rotate 180 deg:
"trfPos": "-y-x", -> "trfPos": "+y+x",
"trfData":[2,0], ->  "trfData":[0,0], (2 times)
"roi":[721, 735, 400, 400], -> "roi":[740, 958, 400, 400],


cd /scratch/detectorData/cSAXS_donnelly_omni_2015_09/
cp -r $SRC/analysis/S03810/ analysis/
cp -r $SRC/matlab/ptycho/ matlab/
cp    $SRC/specES1/omni/omniscan_scan_03810.dat specES1/omni
tar -xvf pilatus_S03810-03819.tar.gz --wildcards 'pilatus_1/S03000-03999/S03810/*'

sed -e s"|3818|3810|" -i $OUTDIR/ptycho.json
sed -e s"|S03810/S03818_S03819_|S03818/S03818_S03819_|" -i $OUTDIR/ptycho.json

ptychoPrep --meta /tmp/ptycho.json --cmpr s-zlib4 --multiproc
ptychoRun /tmp/ptycho_data.hdf5 $OUTDIR/ptycho_init.hdf5 $OUTDIR/ptycho_out3.hdf5
ptychoShow $OUTDIR/ptycho_out3.hdf5

----------------
Normalization
=============

Position 125/136 on measurement 0
31621  and from the CSAXS data 22.2029948366
400*400

maxPwr=31621*400*400/(22.2029948366)**2=10262956.000011036

ptychoPrep --meta /home/zamofing_t/Documents/prj/libDetXR/python/libDetXR/ptycho/cSAXS_donnelly_omni_2015_09_3818.json -v31 --oldHdfStruct --maxPower 10262956
PRODUCES VERY SIMILAR INPUT DATA (not verified with prycho processing)!!!

Important files:
/afs/psi.ch/project/cxs/CDI/cSAXS_donnelly_omni_2015_09/matlab/ptycho/ptycho_offilne_MGS_TEST_modes_S03380.m
/home/zamofing_t/Documents/prj/libDetXR/python/libDetXR/ptycho/extract_cSAXS_donnelly_omni_2015_09_3818.py
/home/zamofing_t/Documents/prj/libDetXR/python/libDetXR/ptycho/cSAXS_donnelly_omni_2015_09_3818.json
/home/zamofing_t/Documents/prj/libDetXR/python/libDetXR/ptycho/ptycho_template.json


cd /scratch/detectorData/cSAXS_donnelly_omni_2015_09/analysis/S03818
ptychoPrep --meta /home/zamofing_t/Documents/prj/libDetXR/python/libDetXR/ptycho/cSAXS_donnelly_omni_2015_09_3818.json -v31 --oldHdfStruct
ptychoPrep --meta /home/zamofing_t/Documents/prj/libDetXR/python/libDetXR/ptycho/cSAXS_donnelly_omni_2015_09_3818.json -v31 --oldHdfStruct --maxPower 10262956

h5pyViewer S03818_S03819_data_400x400.h5
h5pyViewer /tmp/ptycho_data.hdf5&

