#!/usr/bin/python
import h5py
import numpy as np

def RunWithArgs(args):
  fIn=h5py.File(args.input,'r')
  data=np.uint32(fIn['data'])
  fOut=h5py.File(args.output,'w')
  g=fOut.create_group('entry')
  ds=g.create_dataset('data',data=data)
  fOut.close()


if __name__ == '__main__':
  import os,sys,argparse #since python 2.7
  def ParseArgs():
    (h,t)=os.path.split(sys.argv[0]);cmd='\n  '+(t if len(h)>3 else sys.argv[0])+' '
    exampleCmd=('-i input.mat -o output.hdf5',
                '-i /afs/psi.ch/project/cxs/CDI/cSAXS_sxdm_2014_07_omny_commissioning/analysis/S01999/S01999_data_400x400.mat -o /tmp/ptycho_data.hdf5'
                )
    epilog='''\n

Examples:
'''+''.join(map(lambda s:cmd+s,exampleCmd))+'\n '

    parser = argparse.ArgumentParser(formatter_class=argparse.RawDescriptionHelpFormatter,
                                     description=__doc__,
                                     epilog=epilog)

    parser.add_argument('-i', '--input',  required=True, help='data source')
    parser.add_argument('-o', '--output', required=True, help='data destination')

    args = parser.parse_args()
    RunWithArgs(args)

ParseArgs()