
import h5py,sys
import matplotlib.pyplot as plt
import numpy as np

f2=h5py.File('/scratch/detectorData/cSAXS_donnelly_omni_2015_09/analysis/S03818/S03818_S03819_data_400x400.h5','r')

for det in ('detector_0','detector_1'):
  g=f2['detectors'][det]['modules']
  print 'modules of',det, g.value[:,::-1]

g=f2['measurements']

maxBadPix=32

pos=np.zeros((len(g),2), dtype=np.int32)
detector=np.zeros((len(g)), dtype=np.int32)
probe=np.zeros((len(g)), dtype=np.int32)
object=np.zeros((len(g)), dtype=np.int32)
badPix=np.zeros((len(g),maxBadPix,2), dtype=np.int32)-1


print 'pos=['
for k,v in g.iteritems():
  idx=int(k.split('_')[1])
  a=v.attrs
  detector[idx]=a['detector']
  probe[idx]   =a['probe']
  object[idx]  =a['object']
  pos[idx,:]   =a['position']
  bp=v['bad_pixels']
  badPix[idx,0:bp.shape[0],:]=bp.value[:,::-1]

#sys.stdout.write('[%d,%d],'%tuple(p))

print 'detector',detector
print 'probe',probe
print 'object',object
d=-1
detector[0]
for i in range(pos.shape[0]):
  if d!=detector[i]:
    if d!=-1: print ']'
    d=detector[i]
    sys.stdout.write('badPix %d pos ['%d)
    for j in range(maxBadPix):
      if badPix[i,j,0]==-1:
        break
      sys.stdout.write('[%d,%d],'%tuple(badPix[i,j,:]))
    print ']'
    sys.stdout.write('detector %d pos ['%d)
  else:
    assert (badPix[i,:,:]==badPix[i,:,:]).all() #all bad pixels must be identical
  sys.stdout.write('[%d,%d],'%tuple(pos[i,:]))
print ']'


plt.plot(pos)
plt.show()

f=h5py.File('/tmp/ptycho_data.hdf5','r')
pos_m0=f['measurement']['0']['positions'].value
pos_m1=f['measurement']['1']['positions'].value


diff1=pos_m0-pos[:440,:]
diff2=pos_m0-pos[440:,:]
plt.plot(diff1[:,0],diff1[:,1],'-o')
plt.plot(diff1,'-o')
plt.show()

plt.plot(pos[:,0],pos[:,1],'-o')
plt.show()
plt.hold()
plt.plot(pos2[:,0],pos2[:,1],'r-o')
plt.show()


plt.plot(pos[:,0],pos[:,1],'-o')
p=pos+diff1*10
plt.hold()
#plt.plot(p[:10,0],p[:10,1],'g-*')
plt.plot(p[:,0],p[:,1],'g-*')
plt.show()


