#!/bin/bash
#1                               +––––––––––––––+
#                        hdf5    |              |   hdf5
#                       +––––––->| procRoitStat +–––--->
#                                |              |
#                                +––––––––––––––+
#
#2                               +––––––––––––––+             +–––––––––––+
#                        hdf5    |              |    8081     |           |
#                      +––––––-->| procRoitStat +–––––––––––+>| zmqWriter |
#                                |              |             |           |
#                                +––––––––––––––+             +–––––––––––+
#
#3 +-----------+                 +––––––––––––––+
#  |           |   8080          |              |   hdf5
#  | zmqImgSrc +––––––––––––––-->| procRoitStat +–––--->
#  |           |                 |              |
#  +-----------+                 +––––––––––––––+
#
#4 +-----------+                 +––––––––––––––+             +–––––––––––+
#  |           |   8080          |              |    8081     |           |
#  | zmqImgSrc +––––––––––––––-->| procRoitStat +–––––––––––+>| zmqWriter |
#  |           |                 |              |             |           |
#  +-----------+                 +––––––––––––––+             +–––––––––––+
#
source configTest.sh

ARGS="--cmpr zlib4 -v259 -m"
#ARGS="--cmpr zlib4 -v259"

SRCHDF=$INDIR/cSAXS_2013_10_e14608_georgiadis_3D_for_Marianne/scan_00106.hdf5
#SRCHDF=$INDIR/cSAXS_2013_10_e14608_georgiadis_3D_for_Marianne/scan_00106-00161.hdf5
SRCELEM=/entry/data/pilatus_1
DSTELEM=entry/data/roiStat

ANADIR=$INDIR/cSAXS_2013_10_e14608_georgiadis_3D_for_Marianne/analysis/data/
ROI="--matRoi $ANADIR/pilatus_valid_mask.mat $ANADIR/pilatus_integration_mask.mat"

RunTest()
{
case "$1" in
1) #1 hdf -> hdf
$LXR/procRoiStat.py --src hdf $SRCHDF $SRCELEM --dst hdf $OUTDIR/procRoiStat1.hdf5 $DSTELEM $ROI $ARGS
;;
2) #2  hdf -> zmq
$XT0 "$LXR/zmqWriter.py --addr tcp://*:8081 --dst hdf $OUTDIR/procRoiStat2.hdf5 $DSTELEM --timeout 5000 -v;$ENDCMD"&
$LXR/procRoiStat.py --src hdf $SRCHDF $SRCELEM --dst zmq addr:tcp://localhost:8081 qs:4 if:PUSH timeout:5000 $ROI $ARGS
;;
3) #3 zmq -> hdf
$XT0 "$LXR/zmqImageSource.py -v --addr=tcp://*:8080 --src hdf $SRCHDF $SRCELEM -s;$ENDCMD"&
$LXR/procRoiStat.py --src zmq addr:tcp://localhost:8080 qs:4 if:PULL timeout:5000 --dst hdf $OUTDIR/procRoiStat3.hdf5 $DSTELEM $ROI $ARGS
;;
4) #4 zmq -> zmq
$XT0 "$LXR/zmqImageSource.py -v --addr tcp://*:8080 --src hdf $SRCHDF $SRCELEM -s;$ENDCMD"&
$XT1 "$LXR/zmqWriter.py --addr tcp://*:8081 --dst hdf $OUTDIR/procRoiStat4.hdf5 $DSTELEM --timeout 5000 -v;$ENDCMD"&
$LXR/procRoiStat.py --src zmq addr:tcp://localhost:8080 qs:4 if:PULL timeout:5000 --dst zmq addr:tcp://localhost:8081 qs:4 if:PUSH timeout:5000 $ROI $ARGS
;;
*) # ------- bug ---------
echo "Unknown parameters"
;;
esac
}

for idx in $*; do
  echo RunTest $idx
  RunTest $idx
  WaitAll
  if [ -z $NO_UI ]; then
    h5pyViewer $OUTDIR/procRoiStat$idx.hdf5
  fi
done

#ls -l $OUTDIR/procRoiStat*

