#!/bin/bash
#1                               +––––––––––––+
#                        hdf5    |            |    .dat files
#                      +––––––-->| procSasFit +–––––––>
#                                |            |
#                                +––––––––––––+
#
#2                               +––––––––––––+
#                        hdf5    |            |   hdf5
#                       +––––––->| procSasFit +–––--->
#                                |            |
#                                +––––––––––––+
#
#3                               +––––––––––––+             +–––––––––––+
#                        hdf5    |            |    8081     |           |
#                      +––––––-->| procSasFit +–––––––––––+>| zmqWriter |
#                                |            |             |           |
#                                +––––––––––––+             +–––––––––––+
#
source configTest.sh

ARGS="--cmpr zlib4 -v259 -m"
#ARGS="--cmpr zlib4 -v259"

SRCHDF=$INDIR/cSAXS_2013_10_e14608_georgiadis_3D_for_Marianne/scan_00106.hdf5
#SRCHDF=$INDIR/cSAXS_2013_10_e14608_georgiadis_3D_for_Marianne/scan_00106-00161.hdf5
SRCELEM=/entry/data/pilatus_1
DSTELEM=entry/data/roiStat

ANADIR=$INDIR/cSAXS_2013_10_e14608_georgiadis_3D_for_Marianne/analysis/data/
ROI="--matRoi $ANADIR/pilatus_valid_mask.mat $ANADIR/pilatus_integration_mask.mat"

RunTest()
{
case "$1" in
1) #1 hdf -> dat
echo '...TODO...'
#$LXR/procSasFit.py --src hdf $SRCHDF $SRCELEM --dst hdf $OUTDIR/procSasFit1.hdf5 $DSTELEM $ROI $ARGS
;;
2) #1 hdf -> hdf
echo '...TODO...'
#$LXR/procSasFit.py --src hdf $SRCHDF $SRCELEM --dst hdf $OUTDIR/procSasFit1.hdf5 $ROI $ARGS
;;
3) #2  hdf -> zmq
echo '...TODO...'
#$LXR/procSasFit.py --src  --dst zmq addr:tcp://localhost:8081 qs:4 if:PUSH timeout:5000 $DSTELEM $ROI $ARGS
;;
*) # ------- bug ---------
echo "Unknown parameters"
;;
esac
}

for idx in $*; do
  echo RunTest $idx
  RunTest $idx
  WaitAll
  if [ -z $NO_UI ]; then
    h5pyViewer $OUTDIR/procSasFit$idx.hdf5
  fi
done

#ls -l $OUTDIR/procRoiStat*

