#!/bin/bash

#                                                                 +-----------+
#                                                                 |           |
#                                                     +------PULL>| zmqWriter |
#  +-----------+                 +-----------+        | 8081      |           |
#  |           |   8080          |           +PUSH----+           +-----------+
#  | zmqImgSrc |+PUSH-------PULL>| zmqBroker |
#  |           |                 |           +PUSH----+           +-----------+
#  +-----------+                 +-----------+        | 8082      |           |
#                                      ^              +------PULL>| zmq2imgGL |
#                                      |                          |           |
#                                      |                          +-----------+
#                                      |
#                                      +
#                                 REST 8091


#alias java='/usr/lib/jvm/java-7-openjdk-amd64/jre/bin/java';java -jar /home/zamofing_t/Documents/prj/broker/ch.psi.eiger.broker-1.2.0.jar

echo "starting zmqWriter"
xterm -geometry 180x15+0+497 -T zmqWriter -e "../zmqWriter.py --server tcp://localhost:8081 --outFile /scratch/detectorData/testZMQ.hdf5 -v;sleep 1d"&
PIDzmqWriter=$!
echo "PIDzmqWriter $PIDzmqWriter"

echo "starting zmq2imgGL"
xterm -geometry 180x15+0+760 -T zmq2imgGL -e "../zmq2imgGL.py --server tcp://localhost:8082;sleep 1d"&
PIDzmq2imgGL=$!
echo "PIDzmq2imgGL $PIDzmq2imgGL"

echo "starting zmqBroker rest server"
xterm -geometry 180x15+0+262 -T zmqBroker -e "java -Xmx1024m -jar /home/zamofing_t/Documents/prj/broker/ch.psi.zmq.broker-2.1.0.jar -p 8091 -c zmqBroker1.xml;sleep 1d"&
PIDzmqBroker=$!
echo "PIDzmqBroker $PIDzmqBroker"
#look at congif: http://localhost:8091/brokerengine/broker/
sleep 5

echo "starting zmqImageSource image source"
xterm -geometry 180x15+0+27 -T zmqImageSource -e "../zmqImageSource.py --src raw uint16 2560 2160 /scratch/detectorData/PCO/ -v -s -i --server tcp://*:8080 ;sleep 1d"&
#xterm -geometry 180x15+0+27 -T zmqImageSource -e "../zmqImageSource.py --src tif /scratch/detectorData/TestTIFF2 -v -s -i --server tcp://*:8080 ;sleep 1d"&
PIDzmqImageSource=$!
echo "PIDzmqImageSource $PIDzmqImageSource"


read -p "press return to kill PIDzmqImageSource $PIDzmqImageSource PIDzmqBroker $PIDzmqBroker PIDzmqWriter $PIDzmqWriter PIDzmq2imgGL $PIDzmq2imgGL"
kill $PIDzmqImageSource $PIDzmqBroker $PIDzmqWriter $PIDzmq2imgGL

