#!/bin/bash

#                                                                 +-----------+
#                                                                 |           |
#                                                     +---------->| zmqWriter |<------+
#  +-----------+                 +-----------+        | 8081      |           |       |
#  |           |   8080          |           +--------+           +-----------+       |
#  | zmqImgSrc |+--------------->| zmqBroker |                                        |
#  |           |                 |           +--------+           +-----------+       |
#  +-----------+                 +-----------+        | 8082      |           |       |
#                                      ^              +---------->| zmqWriter |       |
#                                      |                          |           |       |
#                                      |                          +-----------+       |
#                                      |                                ^             |
#                                      |                                |             |
#                                      |                                +-------------+
#                                      +                                +
#                                 REST 8091                        REST 8090

echo "starting zmqImageSource image source"
xterm -geometry 180x15+0+27 -T zmqImageSource -e "../zmqImageSource.py --src raw uint16 2560 2160 /scratch/detectorData/PCO/ -v -s -i --server tcp://*:8080 -v ;sleep 1d"&
PIDzmqImageSource=$!
echo "PIDzmqImageSource $PIDzmqImageSource"

echo "starting zmqBroker rest server"
xterm -geometry 180x15+0+262 -T zmqBroker -e "java -Xmx1024m -jar /home/zamofing_t/Documents/prj/broker/ch.psi.zmq.broker-2.1.0.jar -p 8091 -c broker.xml;sleep 1d"&
PIDzmqBroker=$!
echo "PIDzmqBroker $PIDzmqBroker"
#look at congif: http://localhost:8091/brokerengine/broker/

echo "starting zmqWriter rest server"
xterm -geometry 180x15+0+497 -T zmqWriter -e "../zmqWriter.py rest --port=8090 -v;sleep 1d"&
PIDzmqWriter=$!
echo "PIDzmqWriter $PIDzmqWriter"

sleep 2
echo "check page http://localhost:8090/ in firefox"
firefox http://localhost:8090/

echo "sending configurations to zmqWriter writer"
#configure zmqWriter writer:
curl -i -X PUT http://localhost:8090/zmqWriter/cam0/config -d '{"outFile": "/scratch/detectorData/testZMQ0.hdf5", "server": "tcp://localhost:8081", "verbose": 1, "timeout":10000}'
curl -i -X PUT http://localhost:8090/zmqWriter/cam1/config -d '{"outFile": "/scratch/detectorData/testZMQ1.hdf5", "server": "tcp://localhost:8082", "verbose": 1, "timeout":10000}'
curl -i -X GET http://localhost:8090/zmqWriter

echo ">>>run/stop the existing instances 'cam0' 'cam1'<<<"
curl -i -X PUT http://localhost:8090/zmqWriter/cam0/run -d 1
curl -i -X PUT http://localhost:8090/zmqWriter/cam1/run -d 1

sleep 2
echo "sending configurations to zmqBroker"
#configure zmqBroker:
#curl -i -X PUT http://localhost:8090/zmqWriter/cam0/config -d '{"outFile": "/scratch/detectorData/testZMQ0.hdf5", "server": "tcp://pc8934.psi.ch:8080", "verbose": 1, "timeout":10000}'
#curl -i -X GET http://localhost:8090/zmqWriter

echo "wait a few seconds before stopping file writing..."
sleep 10
echo "stop file writing..."
curl -i -X PUT http://localhost:8090/zmqWriter/cam0/run -d 0
curl -i -X PUT http://localhost:8090/zmqWriter/cam1/run -d 0
read -p "press return to kill PIDzmqImageSource $PIDzmqImageSource PIDzmqBroker $PIDzmqBroker PIDzmqWriter $PIDzmqWriter"
kill $PIDzmqImageSource $PIDzmqBroker $PIDzmqWriter

