#!/usr/bin/env python
from __future__ import division
import zmq
import h5py
import numpy as np
from time import time,sleep
import os,psutil


fname = "/scratch/zamofing/32bit_2527x2463_liso.hdf5"
#fname = "test_1000x1000.seq.h5"
fsize = os.path.getsize(fname) / (1000 * 1000)
global idx
idx=0

def send_array(socket, A, flags=0, copy=True, track=False):
     """send a numpy array with metadata"""
     global idx
     md = dict(
         htype=["array-1.0", ],
         #dtype=str(A.dtype),
         type=str(A.dtype),
         shape=A.shape,
         frame=idx
     )
     idx=idx+1
     #print md
     socket.send_json(md, flags | zmq.SNDMORE)
     return socket.send(A, flags, copy=copy, track=track)



print 'ProcID:',os.getpid()
process = psutil.Process(os.getpid())
if not hasattr(process,'memory_info'):
  process.memory_info=process.get_memory_info

f = h5py.File(fname, "r")
#data = f["/data"][:]
data = f["entry/data/dataset"][:]
print "Start: Mem %d MB"%(process.memory_info().rss/1024/1024)

ctx = zmq.Context()
skt = ctx.socket(zmq.PUSH)
skt.set_hwm(100)
#skt.bind("ipc://127.0.0.1:5555")
skt.bind("tcp://*:5555")



ti = time()
tti = time()
runs = 100
counter = 0
total_size = 0
psize = 0
#slp=0.1
for j in range(runs):
     for i in xrange(data.shape[0]):
         #skt.send(data[i], 0, copy=True, track=True)
         a = send_array(skt, data[i])
         if counter == 0:
             ti = time()
             s = data[i].nbytes
         total_size += s
         psize += s
         counter += 1
         if counter % 100 == 0:
             print "%.2f MB/s" % (psize / (time() - ti) / 1000000), "Mem %d MB"%(process.memory_info().rss/1024/1024)#,"sleep %g"%slp
             #sleep(slp);slp=slp*1.5
             ti = time()
             psize = 0

te = time() - tti

print "It took %.2f seconds, speed: %.2f MB/s" %(te, total_size / te /
1000000)
