#!/bin/bash

#  +-----------+                 +-----------+
#  |           |   8080          |           |
#  | zmqImgSrc |+--------------->| zmqWriter |
#  |           |                 |           |
#  +-----------+                 +-----------+
#                                      ^
#                                      |
#                                      |
#                                      +
#                                 REST 8090
#
#zmqImgSrc sends PCO raw images (compressed or uncompressed) via zmq (htype=chunk)
#zmqWriter writes to file /scratch/detectorData/testREST0.hdf5

#use xwininfo to get window positions
DST=/tmp/zmqWriterOut
mkdir -p $DST
chmod 777 $DST

echo "starting zmqImageSource"
xterm -geometry 180x15+0+27 -T zmqImageSource -e "../zmqImageSource.py --src raw uint16 2560 2160 /scratch/detectorData/PCO/ -v -s -i --server=tcp://*:8080 -v ;sleep 1d"&
#compressed server
#xterm -geometry 180x15+0+27 -T zmqImageSource -e "../zmqImageSource.py --src raw uint16 2560 2160 /scratch/detectorData/PCO/ -v -s -i --port=8080 -v --cmpr=zlib4;sleep 1d"&
PIDzmqImageSource=$!
echo "PIDzmqImageSource $PIDzmqImageSource"

echo "starting zmq-writer service (not yet as root)"
../../../services/zmq-writer start
sleep 3
echo "check page http://localhost:8090/ in firefox"
firefox http://localhost:8090/

tail +1 /tmp/zmq-writer/*

echo "sending configurations to restServer"

#Test allocation and deletion
curl -i -X PUT http://localhost:8090/cam1/config -d '{"server":"tcp://localhost:8080", "dst":["hdf","'$DST/testZMQcam1.hdf5'","entry/data/dataset"], "numFrm":50, "timeout":1000, "verbose":1, "ifType":"PULL", "cmpr":"s-zlib4","user":"zamofing_t"}'
curl -i -X PUT http://localhost:8090/cam2/config -d '{"server":"tcp://localhost:8080", "dst":["hdf","'$DST/testZMQcam2.hdf5'","entry/data/dataset"], "numFrm":50, "timeout":1000, "verbose":1, "ifType":"PULL", "cmpr":"s-zlib4","user":"testusr"}'

curl -i -X PUT http://localhost:8090/cam2/run
#curl -i -X GET http://localhost:8090/all
#curl -i -X GET http://localhost:8090/info
#curl -i -X DELETE http://localhost:8090/cam1

echo "after 20 sec. the service will be stopped"
sleep 20
echo "the service will be stopped now"
~/Documents/prj/libDetXR/services/zmq-writer stop
kill $PIDzmqImageSource $PIDrestServer
tail +1 /tmp/zmq-writer/*
