#!/usr/bin/env python
from __future__ import division
import zmq
import h5py
import numpy as np
from time import time, sleep
import os,psutil


def recv_array(socket, flags=0, copy=True, track=False):
     """recv a numpy array"""
     md = socket.recv_json(flags=flags)
     msg = socket.recv(flags=flags, copy=copy, track=track)
     buf = buffer(msg)
     #A = np.frombuffer(buf, dtype=md['dtype'])
     A = np.frombuffer(buf, dtype=md['type'])
     return A.reshape(md['shape'])

print 'ProcID:',os.getpid()
process = psutil.Process(os.getpid())
if not hasattr(process,'memory_info'):
  process.memory_info=process.get_memory_info
print "Start: Mem %d MB"%(process.memory_info().rss/1024/1024)

ctx = zmq.Context()
skt = ctx.socket(zmq.PULL)
#skt.connect("tcp://192.168.10.146:5555")
skt.connect("tcp://localhost:5555")
skt.set_hwm(100)

counter = 0
total_size =0
psize = 0
ti = time()
while True: # counter < (1000 - 1):


     #data = skt.recv(0, copy=True, track=True)


     data = recv_array(skt, copy=False, track=True)
     if counter == 0:
         ti = time()
         s = data.nbytes
     total_size += s
     psize += s
     if counter % 100 == 0:
         print "%.2f MB/s" % (psize / (time() - ti) / 1000000), "Mem %d MB"%(process.memory_info().rss/1024/1024)
         ti = time()
         psize = 0
     counter += 1

te = time() - tti

print "It took %.2f seconds, speed: %.2f MB/s" %(te, total_size / te /
1000000)
